*!*	----------------------------------------
*!*	Bang ke thue VAT dau ra
*!*	Nguoi lap trinh: HUNGPN
*!*	Ngay lap trinh: 25/06/2001
*!*	----------------------------------------

PARAMETER m.Dbf, m.MauI
*!*	m.MauI = 1: Mau co seri, 0: Mau khong co so seri

	IF .F.
		_REFOX_ = (9876543210)
	ENDIF

	IF PARA()<2
		m.MauI = "0"
	ENDIF
	
	* + Gan bien
	m.Rep_vnd_nt1 = m_Rep_vnd_nt
	STORE MONTH(DATE()) TO m.Thang1, m.Thang2
	m.Nhan_huy = 1
	m.Tk = "333"
	m.Tk_du = ""
	m.Thue_suat = ""
	M.Ma_thue = ""
	m.Order = "NGAY_CT"
	
	USE (k_cod + "dmtk" + m_nam) ORDER Tk ALIAS m_Dmtk NOUPDATE IN 0
	DO FORM (k_scx + "glthue2")
	USE IN m_Dmtk
	IF m.Nhan_huy <> 1
		RETURN
	ENDIF
	IF m.Thang1 = m.Thang2
		_Thang = "Thng "+TRANS(m.Thang1, "@L 99")+" nm " + m_Nam0
	ELSE
		_Thang = "T thng "+TRANS(m.Thang1, "@L 99")+" nm "+m_Nam0+" n thng "+TRANS(m.Thang2, "@L 99") + " nm " + m_Nam0
	ENDIF
	m.Tk = ALLT(m.Tk)
	m.Tk_Du = ALLT(m.Tk_Du)
	
	WAIT m_Process WINDOW NOWAIT
	
	DO FilterData
	
	WAIT CLEAR
	DO BrowseTable
RETURN

*!*	----------------------------------------
*!*	PROCEDURE FilterData
*!*	----------------------------------------
PROCEDURE FilterData
#DEFINE _STRING_TOTAL "Tng pht sinh"

	_Key = "BETWEEN(MONTH(Ngay_ct), m.Thang1, m.Thang2)"
	
	IF NOT EMPTY(m.Tk)
		IF NOT ("%" $ m.Tk) OR NOT ("_" $ m.Tk)
			m.Tk = ALLT(m.Tk) + "%"
		ENDIF
		_Key = _Key + " AND (Tk_thue_co LIKE m.Tk)"
	ENDIF
	
	IF NOT EMPTY(m.Ma_thue)
		IF NOT ("%" $ m.Ma_thue) OR NOT ("_" $ m.Ma_thue)
			m.Ma_thue = ALLT(m.Ma_thue) + "%"
		ENDIF
		_Key = _Key + " AND (Ma_thue LIKE m.Ma_thue)"
	ENDIF

	IF NOT EMPTY(m.Thue_suat)
		m.Thue_suat = STRTRAN(ALLTRIM(m.Thue_suat), " ", "")
		_Key = _Key + " AND Thue_suat = " + STRTRAN(ALLTRIM(m.Thue_suat), "," , " OR Thue_suat = ")
	ENDIF
		
	IF NOT EMPTY(m.Tk_du)
		IF NOT ("%" $ m.Tk_du) OR NOT ("_" $ m.Tk_du)
			m.Tk_du = ALLT(m.Tk_du) + "%"
		ENDIF
		_Key = _Key + "AND (Tk_du LIKE m.Tk_du)"
	ENDIF
	
	USE (k_dbf + m.Dbf + m_nam) ALIAS k_gt NOUPDATE IN 0

	SELECT *,Space(1) as Nhom,space(1)as Stt, "2" AS Ct ,'2'AS FSort,Space(128)AS Dien_giai ;
		WHERE &_Key ;
		FROM k_gt ;
		INTO DBF (k_tmp + "tThuetmp")
	* Tinh tong thue theo ma thue
	
	USE IN k_gt
		
	SELECT tThueTmp
	INDEX ON Ct +Nhom+Fsort + DTOS(Ngay_ct) + So_ct TAG Ngay_ct
	INDEX ON Ct +Nhom+Fsort + TRANSFORM(Thue_suat, "@L 999.99") + DTOS(Ngay_ct) + So_ct TAG Thue_suat
	INDEX ON Nhom+Fsort +So_ct+Ct+ DTOS(Ngay_ct) TAG So_ct
	USE IN tThuetmp
ENDPROC

*!*	----------------------------------------
*!*	PROCEDURE BrowseTable
*!*	----------------------------------------
PROCEDURE BrowseTable
	SELECT 0
	USE (K_Tmp+"tThueTmp") EXCL ORDER Ngay_Ct
	ON KEY LABEL F7 DO ToExcel
	ON KEY LABEL F10 DO Option
	_Title = "Bang ke chung tu thue GTGT dau ra" + ". F7 - Export Excel, F10 - Sap xep, Esc - Quay ra"
	sDynamicBackColor = "IIF(EMPTY(Ngay_Ct),RGB(230,251,235),RGB(255,255,255))"

	BROWSE FIELDS;
			Nhom,;
			Ma_hdon,;
			KH_MHD,;
			Ma_ct, ;
			So_seri, ;
			_Ngay_ct=IIF(EMPTY(Ngay_ct),SPACE(1),TRAN(DAY(Ngay_ct),"@L 99")+;
					"/"+TRAN(MONTH(Ngay_ct),"@L 99")):H="Ngay_ct":6,;
			So_ct, ;
			Ten_kh:28, ;
			Dia_chi : 30, ;
			Ma_so_thue: 15, ;
			T_tien2: P = "@Z" + m_Ip_Tien, ;
			T_thue: P = "@Z" + m_Ip_Tien, ;
			Ma_thue,;
			Thue_suat: P="@Z999.99", ;
			Ghi_chu, Dien_giai;
			NAME oBrowse NOWAIT;
		WHEN Change_color_of_Browse(RECNO(), sDynamicBackColor) ;
					WINDOW m_WinBrw TITLE _Title
					
	DO HookObjectBrowse
	BROWSE LAST
	USE IN tThuetmp
	ON KEY LABEL F7
	ON KEY LABEL F10
ENDPROC

*!*	----------------------------------------
*!*	PROCEDURE Print
*!*	----------------------------------------
PROCEDURE Print
	SET FILTER TO (Ct = "2" AND T_Tien2#0) OR Fsort='1'
	DO Pr_Report
	SET FILTER TO
RETURN
	
*!*	----------------------------------------
*!*	PROCEDURE Option
*!*	----------------------------------------
PROCEDURE Option
	PUSH KEY CLEAR
	DO FORM (K_Scx + "glthue2f10") 
	POP KEY
	SELECT tThueTmp
	SET ORDER TO m.Order
RETURN


*!*	----------------------------------------
*!*	PROCEDURE ToExcel
*!*	----------------------------------------
PROCEDURE ToExcel
	WAIT window "Dang thuc hien ..." nowait
	LOCAL liRowIndex, liColumnIndex, lcAlias
	lcCursor  = ALIAS() && table or cursor name
	SELECT ( lcCursor )
	loExcelSession = CREATEOBJECT('Excel.Application')

	WITH loExcelSession
	   .Visible  = .T.
	   .DisplayAlerts = .F.   && no messages displayed
	ENDWITH
	
	_filexl = 'MAUBR320.xls'
	_file = "C:\EXCEL\" + _filexl
	IF file(_file)
		_Temopen = _file
	ELSE
		_file = "D:\EXCEL\" + _filexl
		IF file(_file)
			_Temopen = _file
		ELSE
			_file = "E:\EXCEL\" + _filexl
			IF file(_file)
				_Temopen = _file
			ELSE
				_Temopen = FULLPATH(M_root) + 'Excel\' + _filexl
			ENDIF
		ENDIF	
	ENDIF
	
	oExcelWorkbook = loExcelSession.APPLICATION.Workbooks.OPEN(_Temopen) 
	oActiveExcelSheet = oExcelWorkbook.Worksheets(1).ACTIVATE
	XLSHEET = oExcelWorkbook.Worksheets(1)
	
	k = 18
	i = 17
	n=0
	
	SELECT tThueTmp
	count to t1 for allt(ma_thue)=='KT'
	count to t2 for allt(ma_thue)=='00'
	count to t3 for allt(ma_thue)=='05'
	count to t4 for allt(ma_thue)=='10'
	count to t5 for allt(ma_thue)=='KK'
	
	d1=0
		
	SELECT tThueTmp
	SCAN for Ma_thue = 'KT'
		i=i+1
		n=n+1
		
		if i>18 and d1 <t1
			d1 = d1 + 1
			CROW = ALLTRIM(STR(i))
		    XlSheet.Rows("&cRow:&cRow").Insert
		endif
		
		XLSHEET.CELLS(i,2).VALUE = "'"+allt(str(n))
		XLSHEET.CELLS(i,3).VALUE = allt(Ma_Hdon)
		XLSHEET.CELLS(i,4).VALUE = allt(KH_MHD)
		XLSHEET.CELLS(i,5).VALUE = allt(so_seri)
		XLSHEET.CELLS(i,6).VALUE = "'"+allt(so_ct)
		XLSHEET.CELLS(i,7).VALUE = ngay_ct
		XLSHEET.CELLS(i,8).VALUE = Allt(Ten_kh)
		
		XLSHEET.CELLS(i,9).VALUE = "'"+allt(Ma_so_thue)
		
		XLSHEET.CELLS(i,10).VALUE = allt(Ten_vt)
		XLSHEET.CELLS(i,11).VALUE = t_tien2
		XLSHEET.CELLS(i,12).VALUE = t_thue
		XLSHEET.CELLS(i,13).VALUE = allt(ghi_chu)
	ENDSCAN
	
	n=0

	k = 18 + d1 + 3
	i = 17 + d1 + 3
	p = i
	q = k
	d2 = 0
	
	SELECT tThueTmp
	SCAN for Ma_thue = '00'
		i=i+1
		n=n+1
		
		if i>k and d2 < t2
			d2 = d2 + 1
			CROW = ALLTRIM(STR(i))
		    XlSheet.Rows("&cRow:&cRow").Insert
		endif
		XLSHEET.CELLS(i,2).VALUE = "'"+allt(str(n))
		XLSHEET.CELLS(i,3).VALUE = allt(Ma_Hdon)
		XLSHEET.CELLS(i,4).VALUE = allt(KH_MHD)
		XLSHEET.CELLS(i,5).VALUE = allt(so_seri)
		XLSHEET.CELLS(i,6).VALUE = "'"+allt(so_ct)
		XLSHEET.CELLS(i,7).VALUE = ngay_ct
		XLSHEET.CELLS(i,8).VALUE = Allt(Ten_kh)
		
		XLSHEET.CELLS(i,9).VALUE = "'"+allt(Ma_so_thue)
		
		XLSHEET.CELLS(i,10).VALUE = allt(Ten_vt)
		XLSHEET.CELLS(i,11).VALUE = t_tien2
		XLSHEET.CELLS(i,12).VALUE = t_thue
		XLSHEET.CELLS(i,13).VALUE = allt(ghi_chu)
	ENDSCAN
	
	n=0
	
	k = q + 3 + d2
	
	i = p + 3 + d2
	
	p = i
	q = k
	
	d3 = 0

	SELECT tThueTmp
	SCAN for Ma_thue = '05'
		i=i+1
		n=n+1
		
		if i>k and d3 < t3
			d3 = d3 + 1
			CROW = ALLTRIM(STR(i))
		    XlSheet.Rows("&cRow:&cRow").Insert
		endif
		
		XLSHEET.CELLS(i,2).VALUE = "'"+allt(str(n))
		XLSHEET.CELLS(i,3).VALUE = allt(Ma_Hdon)
		XLSHEET.CELLS(i,4).VALUE = allt(KH_MHD)
		XLSHEET.CELLS(i,5).VALUE = allt(so_seri)
		XLSHEET.CELLS(i,6).VALUE = "'"+allt(so_ct)
		XLSHEET.CELLS(i,7).VALUE = ngay_ct
		XLSHEET.CELLS(i,8).VALUE = Allt(Ten_kh)
		
		XLSHEET.CELLS(i,9).VALUE = "'"+allt(Ma_so_thue)
		
		XLSHEET.CELLS(i,10).VALUE = allt(Ten_vt)
		XLSHEET.CELLS(i,11).VALUE = t_tien2
		XLSHEET.CELLS(i,12).VALUE = t_thue
		XLSHEET.CELLS(i,13).VALUE = allt(ghi_chu)
	ENDSCAN
	
	n=0
	
	k = q + 3 + d3
	
	i = p + 3 + d3
	
	p = i
	q = k
	
	d4 = 0
	
	SELECT tThueTmp
	SCAN for Ma_thue = '10'
		i=i+1
		n=n+1
		
		if i>k and d4 < t4
			d4 = d4 + 1
			CROW = ALLTRIM(STR(i))
		    XlSheet.Rows("&cRow:&cRow").Insert
		endif
		
		XLSHEET.CELLS(i,2).VALUE = "'"+allt(str(n))
		XLSHEET.CELLS(i,3).VALUE = allt(Ma_Hdon)
		XLSHEET.CELLS(i,4).VALUE = allt(KH_MHD)
		XLSHEET.CELLS(i,5).VALUE = allt(so_seri)
		XLSHEET.CELLS(i,6).VALUE = "'"+allt(so_ct)
		XLSHEET.CELLS(i,7).VALUE = ngay_ct
		XLSHEET.CELLS(i,8).VALUE = Allt(Ten_kh)
		
		XLSHEET.CELLS(i,9).VALUE = "'"+allt(Ma_so_thue)
		
		XLSHEET.CELLS(i,10).VALUE = allt(Ten_vt)
		XLSHEET.CELLS(i,11).VALUE = t_tien2
		XLSHEET.CELLS(i,12).VALUE = t_thue
		XLSHEET.CELLS(i,13).VALUE = allt(ghi_chu)
	ENDSCAN
	
	n=0
	
	k = q + 3 + d4
	
	i = p + 3 + d4
	
	p = i
	q = k
	
	d5 = 0
	
	SELECT tThueTmp
	SCAN for Ma_thue = 'KK'
		i=i+1
		n=n+1
		
		if i>k and d5 < t5
			d5 = d5 + 1
			CROW = ALLTRIM(STR(i))
		    XlSheet.Rows("&cRow:&cRow").Insert
		endif
		
		XLSHEET.CELLS(i,2).VALUE = "'"+allt(str(n))
		XLSHEET.CELLS(i,3).VALUE = allt(Ma_Hdon)
		XLSHEET.CELLS(i,4).VALUE = allt(KH_MHD)
		XLSHEET.CELLS(i,5).VALUE = allt(so_seri)
		XLSHEET.CELLS(i,6).VALUE = "'"+allt(so_ct)
		XLSHEET.CELLS(i,7).VALUE = ngay_ct
		XLSHEET.CELLS(i,8).VALUE = Allt(Ten_kh)
		
		XLSHEET.CELLS(i,9).VALUE = "'"+allt(Ma_so_thue)
		
		XLSHEET.CELLS(i,10).VALUE = allt(Ten_vt)
		XLSHEET.CELLS(i,11).VALUE = t_tien2
		XLSHEET.CELLS(i,12).VALUE = t_thue
		XLSHEET.CELLS(i,13).VALUE = allt(ghi_chu)
	ENDSCAN
	
	
	_Temsaveas = PUTFILE('xls')
	XLSHEET.SAVEAS(_Temsaveas)

RETURN